﻿using System;
using System.ComponentModel;

namespace Umbraco.Web.Models.ContentEditing
{
    /// <summary>
    /// Represents the type's of Umbraco entities that can be resolved from the EntityController
    /// </summary>
    public enum UmbracoEntityTypes
    {   
        /// <summary>
        /// Domain
        /// </summary>
        Domain,

        /// <summary>
        /// Language
        /// </summary>
        Language,

        /// <summary>
        /// User
        /// </summary>
        User,

        /// <summary>
        /// Macro
        /// </summary>
        Macro,

        /// <summary>
        /// Document
        /// </summary>
        Document,

        /// <summary>
        /// Media
        /// </summary>
        Media,

        /// <summary>
        /// Member Type
        /// </summary>
        MemberType,

        /// <summary>
        /// Template
        /// </summary>
        Template,

        /// <summary>
        /// Member Group
        /// </summary>
        MemberGroup,

        /// <summary>
        /// Content Item
        /// </summary>
        [Obsolete("This is not used and will be removed in future versions")]
        [EditorBrowsable(EditorBrowsableState.Never)]
        ContentItem,

        /// <summary>
        /// "Media Type
        /// </summary>
        MediaType,

        /// <summary>
        /// Document Type
        /// </summary>
        DocumentType,
        
        /// <summary>
        /// Stylesheet
        /// </summary>        
        Stylesheet,

        /// <summary>
        /// Member
        /// </summary>
        Member,

        /// <summary>
        /// Data Type
        /// </summary>
        DataType,

        /// <summary>
        /// Property Type
        /// </summary>
        PropertyType,

        /// <summary>
        /// Property Group
        /// </summary>
        PropertyGroup
    }
}